import { ComparatorFn } from '@collectable/core';
import { RedBlackTreeStructure } from './RedBlackTree';
import { Node, BRANCH } from './node';
export declare class PathNode<K, V> {
    node: Node<K, V>;
    parent: PathNode<K, V>;
    next: BRANCH;
    static NONE: PathNode<any, any>;
    static cache: PathNode<any, any>;
    constructor(node: Node<K, V>, parent: PathNode<K, V>, next: BRANCH);
    static next<K, V>(node: Node<K, V>, parent: PathNode<K, V>, next: BRANCH): PathNode<K, V>;
    static release<K, V>(p: PathNode<K, V>, node?: Node<K, V>): Node<K, V>;
    static releaseAndRecount<K, V>(p: PathNode<K, V>, node: Node<K, V>): Node<K, V>;
    isActive(): boolean;
    isNone(): boolean;
    replace(node: Node<K, V>): void;
    release(): PathNode<K, V>;
}
export declare function findPath<K, V>(tree: RedBlackTreeStructure<K, V>, key: K, root: Node<K, V>, compare: ComparatorFn<K>, p?: PathNode<K, V>): PathNode<K, V>;
export declare function findSuccessor<K, V>(tree: RedBlackTreeStructure<K, V>, p: PathNode<K, V>): PathNode<K, V>;
export declare function clonePath<K, V>(path: PathNode<K, V>): PathNode<K, V>;
